%{

#include "stdmok.h"
#include <math.h>
dbl  GetReal();
void GetText();
char buff[300];

#define OK 300;

#define yywrap() 1

dbl lval;

%}


comment \#(.)*\n
num 	[0-9]
real 	-?{num}+(\.{num}+)?([Ee][+/-]?{num}+)?
separator [ \t\n]
blank {separator}+

%%

"3DG1"          { }
{blank}		{ }
{comment}       { }
{real}		{ 
                  lval = GetReal(); 
		  return OK;
                }

%%

void GetText()
{
  strncpy(buff, yytext, yyleng);
  buff[yyleng] = 0;
}

dbl GetReal ()
{
  char *expo_s;
  dbl   expo;
  
  dbl result;
  GetText();

  if(expo_s = strchr(buff,'e'))
    {
      *expo_s = 0;
       expo_s++;
       expo = atof(expo_s);
       expo = pow(10.0,expo);
       result = atof(buff);
       result *= expo;
    }
  else
    result = atof(buff);

  return result;
}
